// -*- Java -*-
/*!
 * @file Human_Checker.java
 * @date $Date$
 *
 * $Id$
 */

import jp.go.aist.rtm.RTC.Manager;
import jp.go.aist.rtm.RTC.RTObject_impl;
import jp.go.aist.rtm.RTC.RtcDeleteFunc;
import jp.go.aist.rtm.RTC.RtcNewFunc;
import jp.go.aist.rtm.RTC.RegisterModuleFunc;
import jp.go.aist.rtm.RTC.util.Properties;

/*!
 * @class Human_Checker
 * @brief Human_Checker
 */
public class Human_Checker implements RtcNewFunc, RtcDeleteFunc, RegisterModuleFunc {

//  Module specification
//  <rtc-template block="module_spec">
    public static String component_conf[] = {
    	    "implementation_id", "Human_Checker",
    	    "type_name",         "Human_Checker",
    	    "description",       "Human_Checker",
    	    "version",           "1.0.0",
    	    "vendor",            "Nomiyama",
    	    "category",          "Category",
    	    "activity_type",     "STATIC",
    	    "max_instance",      "1",
    	    "language",          "Java",
    	    "lang_type",         "compile",
            // Configuration variables
            "conf.default.robot_id", "Robo:1",
            "conf.default.password", "8073",
            "conf.default.end_point", "http://localhost:8080/PocoServer/services",
            // Widget
            "conf.__widget__.robot_id", "text",
            "conf.__widget__.password", "text",
            "conf.__widget__.end_point", "text",
            // Constraints
    	    ""
            };
//  </rtc-template>

    public RTObject_impl createRtc(Manager mgr) {
        return new Human_CheckerImpl(mgr);
    }

    public void deleteRtc(RTObject_impl rtcBase) {
        rtcBase = null;
    }
    public void registerModule() {
        Properties prop = new Properties(component_conf);
        final Manager manager = Manager.instance();
        manager.registerFactory(prop, new Human_Checker(), new Human_Checker());
    }
}
