// -*- C++ -*-
/*!
 * @file  Human_Tracking.cpp
 * @brief LRFplǐRTC
 * @date $Date$
 *
 * @author Daiki Nomiyama, Shinichi Ishida, Shogo Namatame, Nobuto Matsuhira 
 *         SHIBAURA INSTITUTE OF TECHNOLOGY /  3-7-5 TOYOSU KOUTO-KU TOKYO 135-8548
 *@@@@ Email:md14067@shibaura-it.ac.jp
 *         Tell : 03-5859-8073
 * @author 쌩R
 *         ŉYHƑw@Hw@@BHwU
 *         135-8548 s]LF3-7-5
 *@@@@ Email:md14067@shibaura-it.ac.jp
 *         Tell : 03-5859-8073
 * 
 * CZX
 *
 *
 *
 * $Id$
 */

#ifndef HUMAN_TRACKING_H
#define HUMAN_TRACKING_H
#define max_particles 100
#define NUM_Hmax         11

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/CorbaPort.h>
#include <rtm/DataInPort.h>
#include <rtm/DataOutPort.h>
#include <rtm/idl/BasicDataTypeSkel.h>
#include <rtm/idl/ExtendedDataTypesSkel.h>
#include <rtm/idl/InterfaceDataTypesSkel.h>

// Service implementation headers
// <rtc-template block="service_impl_h">

// </rtc-template>

// Service Consumer stub headers
// <rtc-template block="consumer_stub_h">

// </rtc-template>

using namespace RTC;

/*!
 * @class Human_Tracking
 * @brief LRFplǐRTC
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 *
 */
class Human_Tracking
  : public RTC::DataFlowComponentBase
{
 public:

	struct Data{
	double mem_data_x[1100];//f[^
	double mem_data_x2[1100];//XVpf[^iOƂɎg֐j
	double mem_data_x3[1100];//Qf[^
	int m_different_search[1100];//ltO
	int parson_divide[NUM_Hmax][1100];	//ľo邽߂̕ϐAl[6]ƃf[^[800]̔z
	int LRF_start;
	int LRF_end;
	};
	Data* m_data;


	
	double human_sx[1100];
	double human_sy[1100];
	double human_ex[1100];
	double human_ey[1100];
	double human_dr[1100];
	int move_trace[NUM_Hmax][3];
	int flag_check_start[NUM_Hmax];
	int flag_check_end[NUM_Hmax];
	double ppx_d;
	double ppy_d;
	double theta;
	double G_dist;
	double px_d_other[NUM_Hmax],py_d_other[NUM_Hmax];
	double theta_other[NUM_Hmax];
	double G_dist_other[NUM_Hmax];
	int G_senter_angl[NUM_Hmax];
	double distance_xy[NUM_Hmax][3];
	double distance_xy2[NUM_Hmax][3];
	double distance_xy3[NUM_Hmax][3];
	double distance_S[NUM_Hmax];
	double distance_S2[NUM_Hmax];
	double distance_S3[NUM_Hmax];
	int m_human_in;
	int m_human_out;
	int m_human_wait;
	int tmp_x[NUM_Hmax][100];
	int tmp_y[NUM_Hmax][100];
	int tmp_x2[NUM_Hmax][100];
	int tmp_y2[NUM_Hmax][100];
	int Tracking_check[NUM_Hmax][NUM_Hmax];
	int Human_check[NUM_Hmax];
	//double scale_control;//摜̎ړxύX邽߂̕ϐ

	struct Human{//elf[^[\
		double velocity[11];//
		double vector[11];//
		//double vector[3];//
		clock_t start;
		clock_t  end;
		//ɍWn
		double distance[100];//a
		double theta[100];//px
		//sWn(f[^)
		double x[100];//xW
		double y[100];//yW
		//sWn(ǐՏ)
		double x2[100];//xW
		double y2[100];//yW
		double distance2[100];//a
		double theta2[100];
		//ۑp
		double x3[100];//xW
		double y3[100];//yW
		//MbZ[WO
		int Hum_ID2;
		double S_msg[20];
		int hum_count[11];
		bool count_state;
		int Msg_Lv[5];
		double xp[max_particles];
		double yp[max_particles];
		double xp2[max_particles];
		double yp2[max_particles];
		//double heading[max_particles];
		//int size;
		double  weight[max_particles];
	};
	struct Humans{
		Human human[NUM_Hmax];
	};

	Humans* m_qHuman;
	Humans* m_qHuman2;

	void strong_pass_filter(int scan_range,int filter_limit);
	void weak_add_filter(int scan_range,int filter_limit);
	void parson_devid_method(int scan_range,int filter_limit,int delsize,int LimitAveDistance);
	void trans_memdata_to_pxpy(int count);
	void LRFPocoHuman();
	void Human_Initialize();
	void TARGET_TRACKING(struct Humans *m_MAN);
	void HUMAN_STATE_CALCULATE(struct Humans *m_MAN);
	void HUMAN_MIGRATION_LENGTH(int i,struct Humans *m_MAN);
	void HUMAN_DELETE_COUNT(int i,struct Humans *m_MAN);
	void HUMAN_DELETE(struct Humans *m_MAN);
	void arrayInsert(double data[], int n, double newdata, int k);
	int PrimeNum_Search(int HUMAN_ID[],int MODE);
	int PrimeNum_KILL(int HUMAN_ID[],int KILL_ID);
	void resample( int i, struct Humans *m_MAN,struct Humans *m_MAN2);
	void predict(int i, struct Humans *m_MAN);
	void weight( int i, struct Humans *m_MAN);
	void measure(int i, struct Humans *m_MAN);
	void Data_outport();
	void LRFData_In();





  /*!
   * @brief constructor
   * @param manager Maneger Object
   */
  Human_Tracking(RTC::Manager* manager);

  /*!
   * @brief destructor
   */
  ~Human_Tracking();

  // <rtc-template block="public_attribute">
  
  // </rtc-template>

  // <rtc-template block="public_operation">
  
  // </rtc-template>

  /***
   *
   * The initialize action (on CREATED->ALIVE transition)
   * formaer rtc_init_entry() 
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onInitialize();

  /***
   *
   * The finalize action (on ALIVE->END transition)
   * formaer rtc_exiting_entry()
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onFinalize();

  /***
   *
   * The startup action when ExecutionContext startup
   * former rtc_starting_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onStartup(RTC::UniqueId ec_id);

  /***
   *
   * The shutdown action when ExecutionContext stop
   * former rtc_stopping_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onShutdown(RTC::UniqueId ec_id);

  /***
   *
   * LRFƐڑClǐՂJnD`ʃEBhE𐶐D
   * The activated action (Active state entry action)
   * former rtc_active_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onActivated(RTC::UniqueId ec_id);

  /***
   *@lǐՂID`ʃEBhE폜D
   *
   * The deactivated action (Active state exit action)
   * former rtc_active_exit()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onDeactivated(RTC::UniqueId ec_id);

  /***
   * lmyѕlǐՂsD
   *
   *
   * The execution action that is invoked periodically
   * former rtc_active_do()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
   virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

  /***
   *
   * The aborting action when main logic error occurred.
   * former rtc_aborting_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onAborting(RTC::UniqueId ec_id);

  /***
   *
   * The error action in ERROR state
   * former rtc_error_do()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onError(RTC::UniqueId ec_id);

  /***
   *
   * The reset action that is invoked resetting
   * This is same but different the former rtc_init_entry()
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onReset(RTC::UniqueId ec_id);
  
  /***
   *
   * The state update action that is invoked after onExecute() action
   * no corresponding operation exists in OpenRTm-aist-0.2.0
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onStateUpdate(RTC::UniqueId ec_id);

  /***
   *
   * The action that is invoked when execution context's rate is changed
   * no corresponding operation exists in OpenRTm-aist-0.2.0
   *
   * @param ec_id target ExecutionContext Id
   *
   * @return RTC::ReturnCode_t
   * 
   * 
   */
  // virtual RTC::ReturnCode_t onRateChanged(RTC::UniqueId ec_id);


 protected:
  // <rtc-template block="protected_attribute">
  
  // </rtc-template>

  // <rtc-template block="protected_operation">
  
  // </rtc-template>

  // Configuration variable declaration
  // <rtc-template block="config_declare">
 /*
  * ȉCRtBM[Vp[^[
  *	ڍׂ̓[U[}jAQƂĂD
  */

  /*!
   * @oliő10l܂Łj
   * - Name:  NUM_max
   * - DefaultValue: 6
   * - Unit: l
   * - Constraint: <=10
   */
  int m_NUM_max;
  /*!
   * @őf[^
   * - Name:  environment
   * - DefaultValue: 4000
   * - Unit: mm
   */
  int m_environment;
  /*!
   * @LRFŎgp郌[U̍ŏXebvԍ
   * - Name:  LRFdata_min
   * - DefaultValue: 44
   * - Unit: Xebv
   */
  int m_LRFdata_min;
  /*!
   * @LRFŎgp郌[U̍őXebvԍ
   * - Name:  LRFdata_max
   * - DefaultValue: 725
   * - Unit: Xebv
   */
  int m_LRFdata_max;
  /*!
   * @LRFŎgp郌[U̒ԃXebvԍ
   * - Name:  LRFdata_mid
   * - DefaultValue: 384
   * - Unit: Xebv
   */
   int m_LRFdata_mid;
    /*!@
   * @LRF̃g[^Xebv@
   * - Name:  LRF_steps
   * - DefaultValue: 1024
   * - Unit: Xebv
   */
   int m_LRF_steps;
   /*!
   *   ̌o̍ŏ
   * - Name:  human_width
   * - DefaultValue: 200
   * - Unit: mm
   */
   int m_human_width;
  /*!
   *   lJEgsۂ̓ގ̌ύXpD@@IN,OUT  OUT,IN œގ̌ύXłD@
   * - Name:  Count_mode
   * - DefaultValue: "IN,OUT" 
   * - Range: IN,OUT or OUT,IN
   */
  std::string m_Count_mode;
  /*!
   *   lFsŏ
   * - Name:  Human_set
   * - DefaultValue: 2800
   * - Unit: mm
   */
  int m_Human_set;
   /*!
   *   lǐՏs͈
   * - Name:  Human_TrackingData
   * - DefaultValue: 2500
   * - Unit: mm
   */
  int m_Human_TrackingData;
   /*!
   *   lJEgsۂ̃GA
   * - Name:  Count_area
   * - DefaultValue: 2500
   * - Unit: mm
   */
  int m_Count_area;
  // </rtc-template>

  // DataInPort declaration
  // <rtc-template block="inport_declare">
  //ڂ̓[U[}jAQƂĂD
  RangeData m_range_data;
  /*!
   * @LRFl擾D
   * - Type: RangeData
   * - Unit: mm
   */
  InPort<RangeData> m_range_dataIn;
   // </rtc-template>

  // DataInPort declaration
  // <rtc-template block="inport_declare">
  //ڂ̓[U[}jAQƂĂD
  TimedLongSeq m_humanX;
  /*!
   * @el̈ʒuf[^iw[mm]jo͂D
   * - Type: TimedLongSeq
   * - Number: m_NUM_maxɈˑiő10lj
   * - Unit: mm
   */
  OutPort<TimedLongSeq> m_humanXOut;

  TimedLongSeq m_humanY;
  /*!
   * @el̈ʒuf[^ix[mm]jo͂D
   * - Type: TimedLongSeq
   * - Number: m_NUM_maxɈˑiő10lj
   * - Unit: mm
   */
  OutPort<TimedLongSeq> m_humanYOut;

  TimedLongSeq m_humanV;
  /*!
   * @el̕sf[^i[mm/s]jo͂D
   * - Type: TimedLongSeq
   * - Number: m_NUM_maxɈˑiő10lj
   * - Unit: mm/s
   */
  OutPort<TimedLongSeq> m_humanVOut;

  TimedLongSeq m_humanT;
  /*!
   * @el̕sf[^i[deg]jo͂D
   * - Type: TimedLongSeq
   * - Number: m_NUM_maxɈˑiő10lj
   * - Unit: deg
   */
  OutPort<TimedLongSeq> m_humanTOut;

  TimedLongSeq m_hcount;
  /*!
   * @ގyё؍ݐlf[^o͂D
   * - Type: TimedLongSeq
   * - Number: m_NUM_maxɈˑiő10lj
   * - Unit: deg
   */
  OutPort<TimedLongSeq> m_hcountOut;
  // </rtc-template>


  // DataOutPort declaration
  // <rtc-template block="outport_declare">
  
  // </rtc-template>

  // CORBA Port declaration
  // <rtc-template block="corbaport_declare">
  
  // </rtc-template>

  // Service declaration
  // <rtc-template block="service_declare">
  
  // </rtc-template>

  // Consumer declaration
  // <rtc-template block="consumer_declare">
  
  // </rtc-template>

 private:
  // <rtc-template block="private_attribute">
  
  // </rtc-template>

  // <rtc-template block="private_operation">
  
  // </rtc-template>

};


extern "C"
{
  DLL_EXPORT void Human_TrackingInit(RTC::Manager* manager);
};

#endif // HUMAN_TRACKING_H
