package acceptor;

import org.robotservices.v02.profile.acceptor.IBasic_profile;
import org.robotservices.v02.profile.acceptor.IData_push_profile;
import org.robotservices.v02.profile.acceptor.IMotion_profile;
import org.robotservices.v02.profile.acceptor.IMultimedia_profile;

import com.fujitsu.rsi.server.acceptor.base.AcceptorProfileFactoryBase;

public class AcceptorProfileFactory_impl extends AcceptorProfileFactoryBase {

	private static ThreadLocal<SharedData> local = new ThreadLocal<SharedData>() {
		@Override
		protected SharedData initialValue() {
			return new SharedData();
		}
	};
	@Override
	public IBasic_profile getBasic_profile()
	{
		return new Basic_profile_impl(local.get());
	}

	@Override
	public IData_push_profile getData_push_profile() {
		return new Data_push_profile_impl(local.get());
	}

	@Override
	public IMultimedia_profile getMultimedia_profile() {
		return new Multimedia_profile_impl(local.get());
	}


	@Override
	public IMotion_profile getMotion_profile() {
		return new Motion_profile_impl(local.get());
	}
}