package acceptor;

import static com.fujitsu.rsi.util.DetailCodeManager.*;

import java.util.Date;

import org.robotservices.v02.profile.common.Ret_value;

import com.fujitsu.rsi.helper.BasicProfileHelper;
import com.fujitsu.rsi.server.acceptor.base.BasicProfileBase;
import com.fujitsu.rsi.util.RESULT;

public class Basic_profile_impl extends BasicProfileBase {

	private SharedData sharedData;

	private static long createConvId(String seed) {
		return seed.hashCode();
	}

	public Basic_profile_impl(SharedData sharedData) {
		this.sharedData = sharedData;
	}

	@Override
	public Ret_value close(long arg0) {

		Ret_value ret = new Ret_value();
		BasicProfileHelper helper = new BasicProfileHelper(ret);
		helper.setResult(RESULT.SUCCESS.getResult());
		helper.setDetailCode(DC_INDEFINITE);
		helper.setDetail("");
		return ret;
	}

	@Override
	public Ret_value open(String robotid, String password) {
		Ret_value ret = new Ret_value();
		BasicProfileHelper helper = new BasicProfileHelper(ret);
		String seed = robotid + password + new Date().toString();
		long conv_id = createConvId(seed);
		helper.setResult(RESULT.SUCCESS.getResult());
		helper.setDetailCode(DC_INDEFINITE);
		helper.setConv_id(conv_id);
		RobotWorkerManager rwm = RobotWorkerManager.getInstance();
		String conv_id_str = Long.toString(conv_id);
		rwm.register_conv_id(robotid, conv_id_str);
		rwm.register_robot_id(conv_id_str, robotid);
		sharedData.setRobot_id(robotid);
		sharedData.setConv_id(conv_id);

		return ret;
	}

}
