package acceptor;

import static com.fujitsu.rsi.util.DetailCodeManager.*;
import manager.ApriPocoManager;

import org.robotservices.v02.profile.acceptor.IWorkerTool;
import org.robotservices.v02.profile.common.AttachedFiles;
import org.robotservices.v02.profile.common.Ret_value;

import com.fujitsu.rsi.helper.DataPushProfileHelper;
import com.fujitsu.rsi.server.acceptor.base.DataPushProfileBase;
import com.fujitsu.rsi.util.DetailCodeManager;
import com.fujitsu.rsi.util.RESULT;

public class Data_push_profile_impl extends DataPushProfileBase {
	private SharedData sharedData;
	public Data_push_profile_impl(SharedData sharedData) {
		this.sharedData = sharedData;
	}

	@Override
	public Ret_value start_profile(long conv_id, final IWorkerTool workertool) {
		System.out.println(conv_id);
		Ret_value ret = new Ret_value();
		DataPushProfileHelper helper = new DataPushProfileHelper(ret);
		Long id = sharedData.getConv_id();
		if (id == null || id != conv_id) {
			helper.setResult(RESULT.ERROR.getResult());
			helper.setDetailCode(DC(MMP, START_PROFILE, 0));
			helper.setDetail(MSG(0));
			return ret;
		}
		RobotWorkerManager rwm = RobotWorkerManager.getInstance();
		rwm.registRobot(sharedData.getRobot_id(), workertool);
		helper.setResult(RESULT.SUCCESS.getResult());
		helper.setDetailCode(DC_INDEFINITE);
		helper.setDetail("");
		return ret;
	}

	@Override
	public Ret_value end_profile(long conv_id, final IWorkerTool workertool) {

		Ret_value ret = new Ret_value();
		DataPushProfileHelper helper = new DataPushProfileHelper(ret);
		Long id = sharedData.getConv_id();
		if (id == null || id != conv_id) {
			helper.setResult(RESULT.ERROR.getResult());
			helper.setDetailCode(DC(MMP, END_PROFILE, 0));
			helper.setDetail(MSG(0));
			return ret;
		}
		RobotWorkerManager rwm = RobotWorkerManager.getInstance();
		rwm.unregistRobot(sharedData.getRobot_id());
		helper.setResult(RESULT.SUCCESS.getResult());
		helper.setDetailCode(DC_INDEFINITE);
		helper.setDetail("");
		return ret;
	}

	public Ret_value push_data(long conv_id, String datas,AttachedFiles attached_files) {
			Ret_value ret = new Ret_value();
			RobotWorkerManager rwm = RobotWorkerManager.getInstance();
			String robotid = rwm.get_robot_id(String.valueOf(conv_id));
			ApriPocoManager apm = ApriPocoManager.getInstance();
			apm.set_Pocodata(robotid, datas);
			DataPushProfileHelper helper = new DataPushProfileHelper(ret);
			helper.setDetail("success");
			helper.setResult(RESULT.SUCCESS.getResult());
			helper.setDetailCode(DetailCodeManager.DC_INDEFINITE);
			return ret;
		}

}