package acceptor;

import static com.fujitsu.rsi.util.DetailCodeManager.*;

import org.robotservices.v02.profile.acceptor.IWorkerTool;
import org.robotservices.v02.profile.common.Ret_value;

import com.fujitsu.rsi.helper.MultimediaProfileHelper;
import com.fujitsu.rsi.server.acceptor.base.MultimediaProfileBase;
import com.fujitsu.rsi.util.RESULT;

public class Multimedia_profile_impl extends MultimediaProfileBase {

	private SharedData sharedData;

	public Multimedia_profile_impl(SharedData sharedData) {
		this.sharedData = sharedData;
	}

	@Override
	public Ret_value start_profile(long conv_id, final IWorkerTool workertool) {
		Ret_value ret = new Ret_value();
		MultimediaProfileHelper helper = new MultimediaProfileHelper(ret);
		Long id = sharedData.getConv_id();
		if (id == null || id != conv_id) {
			helper.setResult(RESULT.ERROR.getResult());
			helper.setDetailCode(DC(MMP, START_PROFILE, 0));
			helper.setDetail(MSG(0));
			return ret;
		}
		RobotWorkerManager rwm = RobotWorkerManager.getInstance();
		rwm.registRobot(sharedData.getRobot_id(), workertool);
		helper.setResult(RESULT.SUCCESS.getResult());
		helper.setDetailCode(DC_INDEFINITE);
		helper.setDetail("");
		return ret;
	}

	@Override
	public Ret_value end_profile(long conv_id, IWorkerTool workertool) {
		Ret_value ret = new Ret_value();
		MultimediaProfileHelper helper = new MultimediaProfileHelper(ret);
		Long id = sharedData.getConv_id();
		if (id == null || id != conv_id) {
			helper.setResult(RESULT.ERROR.getResult());
			helper.setDetailCode(DC(MMP, END_PROFILE, 0));
			helper.setDetail(MSG(0));
			return ret;
		}
		RobotWorkerManager rwm = RobotWorkerManager.getInstance();
		rwm.unregistRobot(sharedData.getRobot_id());
		helper.setResult(RESULT.SUCCESS.getResult());
		helper.setDetailCode(DC_INDEFINITE);
		helper.setDetail("");
		return ret;

	}

}