package acceptor;


import java.util.Enumeration;
import java.util.Hashtable;

import org.robotservices.v02.profile.acceptor.IWorkerTool;

public class RobotWorkerManager{

	private static RobotWorkerManager own = new RobotWorkerManager();
	private Hashtable<String, IWorkerTool> robotable = new Hashtable<String, IWorkerTool>();
	private Hashtable<String,String> robot_id = new Hashtable<String,String>();
	private Hashtable<String,String> conv_id = new Hashtable<String,String>();
	RobotWorkerManager() {

	}

	public static RobotWorkerManager getInstance() {
		return own;
	}

	public void registRobot(String id, IWorkerTool workertool) {
		robotable.put(id, workertool);
	}

	public void unregistRobot(String id) {
		robotable.remove(id);
	}

	public IWorkerTool getWorkerTool(String id) {
		return robotable.get(id);
	}

	public void release_WorkerTool(String id){
		robotable.remove(id);
	}

	public Enumeration<String> getRobotIds() {
		return robotable.keys();
	}

	public void register_conv_id(String robotid,String conv_id){
		robot_id.put(robotid,conv_id);
	}

	public String get_conv_id(String robotid){
		return robot_id.get(robotid);
	}

	public void unregister_conv_id(String robotid){
		robot_id.remove(robotid);
	}

	public String get_robot_id(String conv_id_str){
		return conv_id.get(conv_id_str);
	}

	public void register_robot_id(String conv_id_str,String robot_id){
		conv_id.put(conv_id_str, robot_id);
	}

	public void delete_robot_id(String conv_id_str){
		conv_id.remove(conv_id_str);
	}

}
