/*
 * $Id: RobotCameraServlet.java 270 2010-04-28 07:10:26Z itoh $
 *
 * Copyright 2009-2010 Fujitsu Limited.
 * FUJITSU CONFIDENTIAL.
 */
package servlet;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.robotservices.v02.exception.RSiException;
import org.robotservices.v02.profile.acceptor.IWorkerTool;
import org.robotservices.v02.profile.common.Detail_info;
import org.robotservices.v02.profile.common.Ret_value;
import org.robotservices.v02.profile.invoker.IData_push_profile;
import org.robotservices.v02.profile.invoker.IMultimedia_profile;
import org.robotservices.v02.profile.invoker.InvokerProfileFactory;

import acceptor.RSNPRecivedData;
import acceptor.RobotWorkerManager;
import acceptor.SensorCallback;
import acceptor.SensorSessionManager;

import com.fujitsu.rsi.helper.MultimediaProfileHelper;

/**
 * Servlet implementation class MessagePostServlet
 */
public class SensorServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;

	boolean display_mode = true;

	//private String recode_data = "";
	int interval = -1;
	protected void doPost(HttpServletRequest req, final HttpServletResponse res)
			throws ServletException, IOException {
		req.setCharacterEncoding("Windows-31J");
		// リクエストパラメタの取得
		String mode = req.getParameter("mode");
		String robot_id = req.getParameter("robot_id");
		String interval_str = req.getParameter("interval");
		String command = req.getParameter("command");
		String camera_id = req.getParameter("camera_id");
		if(command != null && camera_id != null){
			System.out.println(camera_id);
			RobotWorkerManager rwm = RobotWorkerManager.getInstance();
			IWorkerTool workertool = rwm.getWorkerTool(camera_id);
			InvokerProfileFactory factory = workertool.getProfileFactory();
			IData_push_profile dpp = factory.getData_push_profile();
			long conv_id = workertool.getConv_id();
			System.out.println(command);
			String datas = "<data><command>"+command+"</command></data>";
			try {
				dpp.push_data(conv_id, datas,null);
			} catch (RSiException e) {
				// TODO 自動生成された catch ブロック
				e.printStackTrace();
			}
		}

		if(robot_id != null && mode != null && interval_str != null)
		{
			 //Integer.valueOf(interval_str);
			if(mode.equals("display")){
				display_mode = true;
			}
			else if(mode.equals("stop")){
				display_mode = false;
			}
			long distribution_id = 0;
			long conv_id = 0;
			RobotWorkerManager rwm = RobotWorkerManager.getInstance();
			IWorkerTool workertool = rwm.getWorkerTool(robot_id);
			SensorSessionManager ssm = SensorSessionManager.getInstance();
			if(workertool != null){
				conv_id = workertool.getConv_id();
				SensorCallback sensorCallback =ssm.getCallback(robot_id);
				IMultimedia_profile mp = null;
				if(sensorCallback == null){
					sensorCallback = new SensorCallback();
					ssm.setCallback(robot_id, sensorCallback);
					InvokerProfileFactory factory = workertool.getProfileFactory();
					mp = factory.getMultimedia_profile();
					ssm.setMultimediaProfile(robot_id, mp);
					try {
						interval = Integer.valueOf(interval_str);
						if(interval < 100){
							interval = 100;
						}
						Ret_value ret = mp.distribute_sensor_info(conv_id, "", interval, "", sensorCallback);
						Detail_info info = ret.get_detail_info();
						//distribution_idを取得・登録
						distribution_id = info.get_distribution_id();
						ssm.setDistributionId(robot_id,Long.toString(distribution_id));
						ssm.set_sensor_data(robot_id, "");
						res.setContentType("text/xml; charset=UTF-8");
						PrintWriter out = res.getWriter();
						out.println("");
						out.close();

					} catch (RSiException e) {
						// TODO 自動生成された catch ブロック
						e.printStackTrace();
					}
				}
				else if(sensorCallback != null){
					if(display_mode == true){
						try {
							sensorCallback.semaphore.acquire();
							if(sensorCallback.ret_value != null){
								MultimediaProfileHelper helper = new MultimediaProfileHelper(sensorCallback.ret_value);
								String data = helper.getDetail();
								ssm.set_sensor_data(robot_id, data);
								res.setContentType("text/xml; charset=UTF-8");
								PrintWriter out = res.getWriter();
								out.println(data);
								out.close();
								System.out.println(data);
								RSNPRecivedData.getInstance().set_recive_data("HMD", data);
							}
							else{
								//遅延が発生している場合
								res.setContentType("text/xml; charset=UTF-8");
								PrintWriter out = res.getWriter();
								out.println(ssm.get_sensor_data(robot_id));
								out.close();
							}
						} catch (InterruptedException e) {
							// TODO 自動生成された catch ブロック
							e.printStackTrace();
						}
					}
					else if(display_mode != true){
						distribution_id = Long.valueOf(ssm.getDistributionId(robot_id));
						mp = ssm.getMultimediaProfile(robot_id);
						try {
							mp.stop_distribute_sensor_info(conv_id, distribution_id);
							ssm.releaseCallback(robot_id);
							sensorCallback.semaphore.release();
						} catch (RSiException e) {
							// TODO 自動生成された catch ブロック
							e.printStackTrace();
						}
					}
					sensorCallback.ret_value = null;
					sensorCallback.semaphore.release();
				}
			}
			else if(workertool == null){
				SensorCallback sensorCallback = ssm.getCallback(robot_id);
				if(sensorCallback == null){
					//何もしない
				}
				else if(sensorCallback != null){
					//配信中でworkertoolにエラーが発生した恐れがあるため，再起動させる．
					//workertoolからはconv_idが取得できないためRobotWorkerManagerから取得する．
					String conv_id_str = rwm.get_conv_id(robot_id);
					conv_id = Long.valueOf(conv_id_str);
					rwm.unregister_conv_id(robot_id);
					rwm.unregistRobot(robot_id);
					ssm.releaseCallback(robot_id);
				}
			}
		}else{
			req.getRequestDispatcher("/jsp/sensor.jsp").forward(req, res);
			return;
		}


	}
	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		req.getRequestDispatcher("/jsp/sensor.jsp").forward(req, res);
	}
}

